Private Sub GetWMI(WMIArray, WMIQuery)
On error resume Next
   Set WMIClass = GetObject("winmgmts:{impersonationLevel=impersonate}!\\.\root\wmi")
   If not(WMIClass is nothing) Then Set WMIArray = WMIClass.ExecQuery(WMIQuery)
End Sub

Function BatteryLevel(Charge, MaxCharge, Online)
On error resume Next
   'Calc the full charge
   CALL GetWMI(objBatteryStatus, "Select * from BatteryFullChargedCapacity Where active=true")
   FullCharge = 1
   For Each objBattery in objBatteryStatus
     FullCharge = FullCharge + objBattery.FullChargedCapacity
   Next

   'Get Current Charge
   CurrentCharge = 1
   CALL GetWMI(objBatteryStatus, "Select * from BatteryStatus Where active=true")
   For Each objBattery in objBatteryStatus
     CurrentCharge = CurrentCharge + objBattery.RemainingCapacity
     Online = objBattery.PowerOnline
   Next

   if (CurrentCharge > FullCharge) then
     CurrentCharge = FullCharge
   end if

   Charge = CurrentCharge
   MaxCharge = FullCharge

End Function


Function UpdateBattery()
  'Stop timer becase we might need to animate!!!
  dim lyMeter
  set lyMeter = this.Layers("Meter")
  Charge = 0
  FullCharge = 0
  PowerOn = true
  call BatteryLevel(Charge, FullCharge, PowerOn)
  'Do charge animation if needed
  if ((Charge < FullCharge) and (PowerOn)) then
    this.DeskletLabel = "Charging...  "+CStr(FormatNumber(((Charge / FullCharge) * 100),1)) + "%"
    DoChargeAnimation()
  else
    this.DeskletLabel = CStr(FormatNumber(((Charge / FullCharge) * 100),1)) + "%"
  end if
  lyMeter.MaskValue = (Charge / FullCharge * 255)
End Function

Function DoChargeAnimation()
  set tRefresh = this.Timers("Refresh")
  tRefresh.StopTimer()
  dim lyMeter
  set lyMeter = this.Layers("Meter")
  for cnt = 0 to 255 step 20
    lyMeter.MaskValue = cnt
  next
  tRefresh.ResetTimer()
End Function

Function SaveSetting()
  dim Param
  dim cRefresh
  dim tRefresh
  set Param = this.Parameters("Refresh")
  set cRefresh = this.Controls("Refresh")
  Param.Value = cRefresh.Value
  this.FlipTo(0)
  set tRefresh = this.Timers("Refresh")
  tRefresh.StopTimer()
  UpdateBattery()
  tRefresh.ResetTimer()
End Function


