var scrolling = false;
var scrollingspeed = 120;

//Scroll Text To Screen
function ScrollTextToScreen(){
  var NewsText = this.layers('News');
  NewsText.ClipSource = '-340,0,0,15';
  var scoord = '-340,0,0,15'
  var ecoord = '0,0,340,15';
  var icoord = '10,0,10,0'
  //Slide
  NewsText.Slide(scoord,ecoord,icoord,scrollingspeed,1,true,'DoScrollOffScreenDelay();');
}

//Set the delay before scrolling the text off screen
function DoScrollOffScreenDelay(){
  var Delay = this.timers.New('Delay','%PauseDelay%','ScrollTextOutOfScreen();',1);
  Delay.ResetTimer();

}
//Scroll the text out of the screen
function ScrollTextOutOfScreen(){
  var NewsText = this.layers('News');
  NewsText.ClipSource = '0,0,340,15';
  var scoord = '0,0,340,15'
  var ecoord = NewsText.ImageWidth+',0,'+(NewsText.ImageWidth+340)+',15';
  var icoord = '10,0,10,0'
  //Slide
  NewsText.Slide(scoord,ecoord,icoord,scrollingspeed,1,true,'start();');
}

//Start Timer
function start(){
  scrolling = true;
  var NewsText = this.layers('News');
  var Pos = this.parameters('Pos');
  Pos.Value = parseInt(Pos.Value)+1;
  if (Pos.Value > (this.xmls(0).GetValueCount('//channel/item/title')-1))
    Pos.Value = 0;
  var NewsMsg = this.ConvertToValue('!XMLTXT:[//channel/item[%Pos%+1]/title][\' - \'][//channel/item[%Pos%+1]/description]');
  //Remove all hyper text stuff
  var reg = /(<([^>]+)>)/g;
  NewsMsg = NewsMsg.replace(reg,'');
  NewsMsg = NewsMsg.substring(0,100)+'...';
  NewsText.ClipSource = '-350,0,0,15';
  NewsText.text = NewsMsg;
  NewsText.data = '!XMLTXT:[//channel/item[%Pos%+1]/link]';
  ScrollTextToScreen();
}

function NewXData(){
  if (!scrolling)
    start();
}

//Apply the settings
function ApplySettings(){
  var SiteParam = this.parameters('SiteAddress');
  var SiteVal = this.controls('SiteAddress');
  var RefreshParam = this.parameters('RefreshDelay');
  var RefreshVal = this.controls('RefreshDelay');
  RefreshParam.Value = parseInt(RefreshVal.Value);
  var DelayParam = this.parameters('PauseDelay');
  var DelayVal = this.controls('PauseDelay');
  DelayParam.Value = parseInt(DelayVal.Value);
  var ScrollParam = this.parameters('ScrollingSpeed');
  var ScrollVal = this.controls('ScrollingSpeed');
  ScrollParam.Value = parseInt(ScrollVal.Value);
  scrollingspeed = ScrollParam.Value;
  this.parameters('Pos').Value = 0;
  if (SiteParam.Value != SiteVal.Value)
  {
    SiteParam.Value = SiteVal.Value;
    this.xmls(0).Reset();
  }
  this.FlipTo(0);
  this.ReDraw();
}

//Click News
function ClickNews(){
  var layer = this.GetActiveLayer();
  var link = this.ConvertToValue(layer.data);
  if (link != '')
    this.IO.ShellExecutes(link);
}

//Highlight text
function Highlight(TurnOn){
  var layer = this.GetActiveLayer();
  if (layer)
  {
    if (TurnOn==1)
      layer.FontColor = 'clYellow';
    else
      layer.FontColor = 'clWhite';
  }
}

//Init
function Init(){
   scrollingspeed = this.parameters('ScrollingSpeed').Value;
}
