// main.js

//Update the position of the scroll
function UpdateScrollPosition(){
  var Scroll = this.controls('Scroller');
  var PosParam = this.parameters('Pos');
  Scroll.Value = parseInt(PosParam.Value) + (this.GetMouseScrollValue()*-1);
  PosParam.Value = Scroll.Value;
  this.ReDraw();
}


//Update the new position
function UpdatePos(){
  var PosParam = this.parameters('Pos');
  var Scroll = this.controls('Scroller');
  PosParam.Value = Scroll.Value;
  this.ReDraw();
}

//Update the display
function UpdateDisplay(){
  this.parameters('Pos').Value = 0;
  var Scroller = this.controls('Scroller');
  Scroller.Value = 0;
  var XMLFeed = this.xmls(0);
  var ItemCnt = XMLFeed.GetValueCount('//channel/item');
  if (ItemCnt > 6)
  {
    Scroller.scrollbarsize = ItemCnt-6;
  }
  else
  {
    Scroller.scrollbarsize = 0;
  }
}

//Apply the settings
function ApplySettings(){
  var SiteParam = this.parameters('SiteAddress');
  var SiteVal = this.controls('SiteAddress');
  var RefreshParam = this.parameters('RefreshDelay');
  var RefreshVal = this.controls('RefreshDelay');
  RefreshParam.Value = parseInt(RefreshVal.Value);
  this.parameters('Pos').Value = 0;
  this.controls('Scroller').Value = 0;
  if (SiteParam.Value != SiteVal.Value)
  {
    SiteParam.Value = SiteVal.Value;
    this.xmls(0).Reset();
  }
  this.FlipTo(0);
  this.ReDraw(true);
}

//Click News
function ClickNews(Position){
  var layer = this.GetActiveLayer();
  var PosOffset = parseInt(this.parameters('Pos').Value);
  var MoreInfo = this.ConvertToValue('!XMLTXT:[//channel/item['+(PosOffset+Position)+']/description]');
  var Box = this.Layers('Popup');
  var Msg = this.Layers('MoreInfo');
  var LinkBtn = this.Layers('Link');
  var HideBtn = this.Layers('Hide');
  var reg = /(<([^>]+)>)/g;
  MoreInfo = MoreInfo.replace(reg,'');
  Msg.text = MoreInfo;
  LinkBtn.Data = layer.Data;
  this.LockAllUpdates();
  Msg.visible = true;
  LinkBtn.visible = true;
  Box.visible = true;
  HideBtn.visible = true;
  this.ReDraw();

}
//Go to the link
function GoToLink(){
  var layer = this.GetActiveLayer();
  var link = this.ConvertToValue(layer.data);
  if (link != '')
    this.IO.ShellExecutes(link);
  HideMsg();
}

//Hide message box
function HideMsg(){
  var Box = this.Layers('Popup');
  var Msg = this.Layers('MoreInfo');
  var LinkBtn = this.Layers('Link');
  var HideBtn = this.Layers('Hide');
  this.LockAllUpdates();
  Msg.visible = false;
  LinkBtn.visible = false;
  Box.visible = false;
  HideBtn.visible = false;
  this.ReDraw();
}

//Highlight text
function Highlight(TurnOn){
  var layer = this.GetActiveLayer();
  if (layer)
  {
    if (TurnOn==1)
      layer.FontColor = 'clYellow';
    else
      layer.FontColor = 'clWhite';
  }
}
